<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>LibSylph: Sylph::SylphIterator&lt; Iter &gt; Class Template Reference</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.8 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="classes.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="classes.html"><span>Class&nbsp;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="namespace_sylph.html">Sylph</a>::<a class="el" href="class_sylph_1_1_sylph_iterator.html">SylphIterator</a>
  </div>
</div>
<div class="contents">
<h1>Sylph::SylphIterator&lt; Iter &gt; Class Template Reference</h1><!-- doxytag: class="Sylph::SylphIterator" --><!-- doxytag: inherits="Sylph::Object" --><a class="el" href="class_sylph_1_1_sylph_iterator.html" title="SylphIterator provides a easier-to-use wrapper around STL iterators.">SylphIterator</a> provides a easier-to-use wrapper around STL iterators.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="_iterator_8h-source.html">Sylph/Core/Iterator.h</a>&gt;</code>
<p>
<div class="dynheader">
Inheritance diagram for Sylph::SylphIterator&lt; Iter &gt;:</div>
<div class="dynsection">
<p><center><img src="class_sylph_1_1_sylph_iterator__inherit__graph.png" border="0" usemap="#_sylph_1_1_sylph_iterator_3_01_iter_01_4__inherit__map" alt="Inheritance graph"></center>
<map name="_sylph_1_1_sylph_iterator_3_01_iter_01_4__inherit__map">
<area shape="rect" id="node2" href="class_sylph_1_1_object.html" title="The root of all classes." alt="" coords="53,5,165,35"></map>
<center><font size="2">[<a href="graph_legend.html">legend</a>]</font></center></div>

<p>
<a href="class_sylph_1_1_sylph_iterator-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_sylph_iterator.html#6f74149cc4a6e7a057f51c33ce26709b">SylphIterator</a> (Iter &amp;it)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Creates a new Iterator from an STL-iterator.  <a href="#6f74149cc4a6e7a057f51c33ce26709b"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_sylph_iterator.html#550c350d2d7744a7fd6af44c716fb846">~SylphIterator</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Destructor.  <a href="#550c350d2d7744a7fd6af44c716fb846"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_sylph_iterator.html#24c0cef4d514f69fec6577f55dc93799">hasNext</a> () const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Checks if this iterator has any more entries in forward direction.  <a href="#24c0cef4d514f69fec6577f55dc93799"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual const Iter::reference&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_sylph_iterator.html#5cafc479cfa2742212ed80b4e1b03a4e">next</a> () const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the next entry in the forward direction and moves the iterator one place forward.  <a href="#5cafc479cfa2742212ed80b4e1b03a4e"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_sylph_iterator.html#42de0477358aa16970ef257d041047e3">hasPrevious</a> () const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Checks if this iterator has any more entries in backward direction.  <a href="#42de0477358aa16970ef257d041047e3"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual const Iter::reference&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_sylph_iterator.html#3277c644458465f50deb6713d308309c">previous</a> () const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the next entry in the backward direction and moves the iterator one place backward.  <a href="#3277c644458465f50deb6713d308309c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_sylph_iterator.html#da51b20d4f61fb1728e19100d6da0ba2">front</a> () const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Moves the Iterator to the place "before" the first item, that is, it gives the pointer in the iterator such a value that hasPrevious returns false.  <a href="#da51b20d4f61fb1728e19100d6da0ba2"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_sylph_iterator.html#70994ef8bc524a231b6852f3ce05b94b">back</a> () const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Moves the Iterator to the place "after" the last item, that is, it gives the pointer in the iterator such a value that hasNext returns false.  <a href="#70994ef8bc524a231b6852f3ce05b94b"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual std::idx_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_sylph_iterator.html#fe653e20cc020e9fea58b2e0b8be8ab9">nextIndex</a> () const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the next index of the Iterable in the forward direction.  <a href="#fe653e20cc020e9fea58b2e0b8be8ab9"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual std::idx_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_sylph_iterator.html#9966f87c9c01a9a13523a34568989124">previousIndex</a> () const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the next index of the Iterable in the backward direction.  <a href="#9966f87c9c01a9a13523a34568989124"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_sylph_iterator.html#dea685b03c30249496bdd82f303323d5">set</a> (typename Iter::reference t)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Replaces the last item returned by <a class="el" href="class_sylph_1_1_sylph_iterator.html#5cafc479cfa2742212ed80b4e1b03a4e" title="Returns the next entry in the forward direction and moves the iterator one place...">next()</a> or <a class="el" href="class_sylph_1_1_sylph_iterator.html#3277c644458465f50deb6713d308309c" title="Returns the next entry in the backward direction and moves the iterator one place...">previous()</a> with the given item.  <a href="#dea685b03c30249496bdd82f303323d5"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="2f46f4a09608eb6d53e4148f23805b6f"></a><!-- doxytag: member="Sylph::SylphIterator::operator++" ref="2f46f4a09608eb6d53e4148f23805b6f" args="() const " -->
const Iter::reference&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_sylph_iterator.html#2f46f4a09608eb6d53e4148f23805b6f">operator++</a> () const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Synonymous for <a class="el" href="class_sylph_1_1_sylph_iterator.html#5cafc479cfa2742212ed80b4e1b03a4e" title="Returns the next entry in the forward direction and moves the iterator one place...">next()</a>. <br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="62ec59cb349ca1e92fbcbe75176d5c4f"></a><!-- doxytag: member="Sylph::SylphIterator::operator&#45;&#45;" ref="62ec59cb349ca1e92fbcbe75176d5c4f" args="() const " -->
const Iter::reference&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_sylph_iterator.html#62ec59cb349ca1e92fbcbe75176d5c4f">operator--</a> () const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Synonymous for <a class="el" href="class_sylph_1_1_sylph_iterator.html#3277c644458465f50deb6713d308309c" title="Returns the next entry in the backward direction and moves the iterator one place...">previous()</a>. <br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">const Iter::reference&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_sylph_iterator.html#3ea8e165a6e4438fcb82f86117f0b16d">operator++</a> (int) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Synoynmous for <a class="el" href="class_sylph_1_1_sylph_iterator.html#5cafc479cfa2742212ed80b4e1b03a4e" title="Returns the next entry in the forward direction and moves the iterator one place...">next()</a>.  <a href="#3ea8e165a6e4438fcb82f86117f0b16d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">const Iter::reference&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_sylph_iterator.html#40260b5a6935ec8b2403680e34e9e91f">operator--</a> (int) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Synonymous for <a class="el" href="class_sylph_1_1_sylph_iterator.html#3277c644458465f50deb6713d308309c" title="Returns the next entry in the backward direction and moves the iterator one place...">previous()</a>.  <a href="#40260b5a6935ec8b2403680e34e9e91f"></a><br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
<h3>template&lt;class Iter&gt;<br>
 class Sylph::SylphIterator&lt; Iter &gt;</h3>

<a class="el" href="class_sylph_1_1_sylph_iterator.html" title="SylphIterator provides a easier-to-use wrapper around STL iterators.">SylphIterator</a> provides a easier-to-use wrapper around STL iterators. 
<p>
The interface of a <a class="el" href="class_sylph_1_1_sylph_iterator.html" title="SylphIterator provides a easier-to-use wrapper around STL iterators.">SylphIterator</a> is similar to a Java-style iterator, but it is backed by a STL iterator and can therefore be used for any class supporitng STL iterators. <hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="6f74149cc4a6e7a057f51c33ce26709b"></a><!-- doxytag: member="Sylph::SylphIterator::SylphIterator" ref="6f74149cc4a6e7a057f51c33ce26709b" args="(Iter &amp;it)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Iter &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_sylph_1_1_sylph_iterator.html">Sylph::SylphIterator</a>&lt; Iter &gt;::<a class="el" href="class_sylph_1_1_sylph_iterator.html">SylphIterator</a>           </td>
          <td>(</td>
          <td class="paramtype">Iter &amp;&nbsp;</td>
          <td class="paramname"> <em>it</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Creates a new Iterator from an STL-iterator. 
<p>
An Iterator can either be constructed explicitly with this constructor, in which case the correct type of Iterator for the particular collection needs to be known, or through Iterable::iterator() or Iterable::mutableIterator() . <dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>it</em>&nbsp;</td><td>The iterable to iterate over. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="550c350d2d7744a7fd6af44c716fb846"></a><!-- doxytag: member="Sylph::SylphIterator::~SylphIterator" ref="550c350d2d7744a7fd6af44c716fb846" args="()" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Iter &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="class_sylph_1_1_sylph_iterator.html">Sylph::SylphIterator</a>&lt; Iter &gt;::~<a class="el" href="class_sylph_1_1_sylph_iterator.html">SylphIterator</a>           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Destructor. 
<p>
This destructor does nothing. 
</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="70994ef8bc524a231b6852f3ce05b94b"></a><!-- doxytag: member="Sylph::SylphIterator::back" ref="70994ef8bc524a231b6852f3ce05b94b" args="() const " -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Iter &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="class_sylph_1_1_sylph_iterator.html">Sylph::SylphIterator</a>&lt; Iter &gt;::back           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Moves the Iterator to the place "after" the last item, that is, it gives the pointer in the iterator such a value that hasNext returns false. 
<p>
This method is useful for backward iterating, i.e. <pre>Iterator it = coll.getIterator(); // normal 'forward' iterator
 it.back(); // ready for backward iteration </pre> 
</div>
</div><p>
<a class="anchor" name="da51b20d4f61fb1728e19100d6da0ba2"></a><!-- doxytag: member="Sylph::SylphIterator::front" ref="da51b20d4f61fb1728e19100d6da0ba2" args="() const " -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Iter &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="class_sylph_1_1_sylph_iterator.html">Sylph::SylphIterator</a>&lt; Iter &gt;::front           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Moves the Iterator to the place "before" the first item, that is, it gives the pointer in the iterator such a value that hasPrevious returns false. 
<p>
<dl class="user" compact><dt><b>Note:</b></dt><dd>This requires that the backing iterator is a bidirectional iterator. </dd></dl>

</div>
</div><p>
<a class="anchor" name="24c0cef4d514f69fec6577f55dc93799"></a><!-- doxytag: member="Sylph::SylphIterator::hasNext" ref="24c0cef4d514f69fec6577f55dc93799" args="() const " -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Iter &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="class_sylph_1_1_sylph_iterator.html">Sylph::SylphIterator</a>&lt; Iter &gt;::hasNext           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Checks if this iterator has any more entries in forward direction. 
<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd><em>true</em> if there are more entries, <em>false</em> otherwise. </dd></dl>

</div>
</div><p>
<a class="anchor" name="42de0477358aa16970ef257d041047e3"></a><!-- doxytag: member="Sylph::SylphIterator::hasPrevious" ref="42de0477358aa16970ef257d041047e3" args="() const " -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Iter &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="class_sylph_1_1_sylph_iterator.html">Sylph::SylphIterator</a>&lt; Iter &gt;::hasPrevious           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Checks if this iterator has any more entries in backward direction. 
<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd><em>true</em> if there are more entries, <em>false</em> otherwise. </dd></dl>
<dl class="user" compact><dt><b>Note:</b></dt><dd>This requires that the backing iterator is a bidirectional iterator. </dd></dl>

</div>
</div><p>
<a class="anchor" name="5cafc479cfa2742212ed80b4e1b03a4e"></a><!-- doxytag: member="Sylph::SylphIterator::next" ref="5cafc479cfa2742212ed80b4e1b03a4e" args="() const " -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Iter &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">virtual const Iter::reference <a class="el" href="class_sylph_1_1_sylph_iterator.html">Sylph::SylphIterator</a>&lt; Iter &gt;::next           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the next entry in the forward direction and moves the iterator one place forward. 
<p>
<dl compact><dt><b>Exceptions:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em><a class="el" href="class_sylph_1_1_exception.html" title="This class provides a ready-to-use interface for exception handling.">Exception</a></em>&nbsp;</td><td>if there are no more entries. </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>The next entry </dd></dl>

</div>
</div><p>
<a class="anchor" name="fe653e20cc020e9fea58b2e0b8be8ab9"></a><!-- doxytag: member="Sylph::SylphIterator::nextIndex" ref="fe653e20cc020e9fea58b2e0b8be8ab9" args="() const " -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Iter &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">virtual std::idx_t <a class="el" href="class_sylph_1_1_sylph_iterator.html">Sylph::SylphIterator</a>&lt; Iter &gt;::nextIndex           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the next index of the Iterable in the forward direction. 
<p>
<dl compact><dt><b>Exceptions:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em><a class="el" href="class_sylph_1_1_exception.html" title="This class provides a ready-to-use interface for exception handling.">Exception</a></em>&nbsp;</td><td>if there are no more entries. </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>The next index in the Iterable </dd></dl>
<dl class="user" compact><dt><b>Note:</b></dt><dd>This method requires the backing iterator to be a random-access iterator. </dd></dl>

</div>
</div><p>
<a class="anchor" name="3ea8e165a6e4438fcb82f86117f0b16d"></a><!-- doxytag: member="Sylph::SylphIterator::operator++" ref="3ea8e165a6e4438fcb82f86117f0b16d" args="(int) const " -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Iter &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">const Iter::reference <a class="el" href="class_sylph_1_1_sylph_iterator.html">Sylph::SylphIterator</a>&lt; Iter &gt;::operator++           </td>
          <td>(</td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Synoynmous for <a class="el" href="class_sylph_1_1_sylph_iterator.html#5cafc479cfa2742212ed80b4e1b03a4e" title="Returns the next entry in the forward direction and moves the iterator one place...">next()</a>. 
<p>
<dl class="user" compact><dt><b>Note:</b></dt><dd>No copy of this iterator is made. </dd></dl>

</div>
</div><p>
<a class="anchor" name="40260b5a6935ec8b2403680e34e9e91f"></a><!-- doxytag: member="Sylph::SylphIterator::operator&#45;&#45;" ref="40260b5a6935ec8b2403680e34e9e91f" args="(int) const " -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Iter &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">const Iter::reference <a class="el" href="class_sylph_1_1_sylph_iterator.html">Sylph::SylphIterator</a>&lt; Iter &gt;::operator--           </td>
          <td>(</td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Synonymous for <a class="el" href="class_sylph_1_1_sylph_iterator.html#3277c644458465f50deb6713d308309c" title="Returns the next entry in the backward direction and moves the iterator one place...">previous()</a>. 
<p>
<dl class="user" compact><dt><b>Note:</b></dt><dd>No copy is of this iterator is made. </dd></dl>

</div>
</div><p>
<a class="anchor" name="3277c644458465f50deb6713d308309c"></a><!-- doxytag: member="Sylph::SylphIterator::previous" ref="3277c644458465f50deb6713d308309c" args="() const " -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Iter &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">virtual const Iter::reference <a class="el" href="class_sylph_1_1_sylph_iterator.html">Sylph::SylphIterator</a>&lt; Iter &gt;::previous           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the next entry in the backward direction and moves the iterator one place backward. 
<p>
<dl compact><dt><b>Exceptions:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em><a class="el" href="class_sylph_1_1_exception.html" title="This class provides a ready-to-use interface for exception handling.">Exception</a></em>&nbsp;</td><td>if there are no more entries. </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>The previous entry </dd></dl>
<dl class="user" compact><dt><b>Note:</b></dt><dd>This requires that the backing iterator is a bidirectional iterator. </dd></dl>

</div>
</div><p>
<a class="anchor" name="9966f87c9c01a9a13523a34568989124"></a><!-- doxytag: member="Sylph::SylphIterator::previousIndex" ref="9966f87c9c01a9a13523a34568989124" args="() const " -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Iter &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">virtual std::idx_t <a class="el" href="class_sylph_1_1_sylph_iterator.html">Sylph::SylphIterator</a>&lt; Iter &gt;::previousIndex           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the next index of the Iterable in the backward direction. 
<p>
<dl compact><dt><b>Exceptions:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em><a class="el" href="class_sylph_1_1_exception.html" title="This class provides a ready-to-use interface for exception handling.">Exception</a></em>&nbsp;</td><td>if there are no more entries. </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>The previous index in the Iterable </dd></dl>
<dl class="user" compact><dt><b>Note:</b></dt><dd>This method requires the backing iterator to be a random-access iterator. </dd></dl>

</div>
</div><p>
<a class="anchor" name="dea685b03c30249496bdd82f303323d5"></a><!-- doxytag: member="Sylph::SylphIterator::set" ref="dea685b03c30249496bdd82f303323d5" args="(typename Iter::reference t)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Iter &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="class_sylph_1_1_sylph_iterator.html">Sylph::SylphIterator</a>&lt; Iter &gt;::set           </td>
          <td>(</td>
          <td class="paramtype">typename Iter::reference&nbsp;</td>
          <td class="paramname"> <em>t</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Replaces the last item returned by <a class="el" href="class_sylph_1_1_sylph_iterator.html#5cafc479cfa2742212ed80b4e1b03a4e" title="Returns the next entry in the forward direction and moves the iterator one place...">next()</a> or <a class="el" href="class_sylph_1_1_sylph_iterator.html#3277c644458465f50deb6713d308309c" title="Returns the next entry in the backward direction and moves the iterator one place...">previous()</a> with the given item. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>t</em>&nbsp;</td><td>The item to replace the last returned item with. </td></tr>
  </table>
</dl>

</div>
</div><p>
</div>
<hr size="1" class="unhidden"><address style="text-align: right;"><small>
Documentation for LibSylph by Doxygen
</body>
</html>
